<template>
  <div class="card">
  <h3>Create new Kitten</h3>
    <div class="formgrid grid">

      <div class="field col-12 md:col-6">
        <label for="nameInput">Name: </label>
        <InputText id="nameInput" class="w-full" type="text" v-model="kittenData.name" placeholder="Whiskers" />
      </div>
      <div class="field col-12 md:col-6">
        <label for="colorInput">Color: </label>
        <InputText id="colorInput" class="w-full" type="text" v-model="kittenData.color" placeholder="Black" />
      </div>

      <div class="field col-12 md:col-2">
        <label for="numberInput">Age: </label>
        <InputText id="numberInput" class="w-full" type="number" v-model="kittenData.age"/>
      </div>

      <div class="field col-12 md:col-2">
        Gender:
        <div class="flex align-items-center" style="height:46px;">
          <div class="mr-4" >
          <RadioButton inputId="rb1" name="gender" v-model="kittenData.gender" value="0" />
          <label for="rb1"> &#9794; </label>
          </div>
          <div>
          <RadioButton inputId="rb2" name="gender" v-model="kittenData.gender" value="1" />
          <label for="rb2"> &#9792; </label>
          </div>
        </div>
      </div>



    </div>
      <Button @click="cancelCreation" label="Cancel" class="p-button-warning"/>
      <Button @click="createKitten" label="Create"/>
  </div>
</template>

<script>
import { API } from 'aws-amplify';
import { createKitten } from '../graphql/mutations';
import KittenDisplay from './KittenDisplay.vue';

export default {
  components: { KittenDisplay },
  name: 'CreateKittenForm',
  data() {
    return {
      kittenData: {
        name: '',
        gender: 0,
        age: null,
        color: ''
      }
    }
  },
  emits: [
    'requestToggleDisplay'
  ],
  methods: {
    async createKitten(){
      // ToDo gerer validations des données
      const kittenPayload = this.kittenData;
      await API.graphql({
        query: createKitten,
        variables: {input: kittenPayload}
      });
      this.$emit('requestToggleDisplay');
    },
    cancelCreation(){
      this.kittenData = {
        name: '',
        gender: 0,
        age: null,
        color: ''
      };
      this.$emit('requestToggleDisplay')
    },
    
  }
}
</script>